indexing

   title:       "Abstract formatter with justify actions";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "absj_fmt.e"

deferred class ABSTRACT_JUSTIFY_FORMATTER

inherit
   STRING_TOOLS
   ABSTRACT_FORMATTER
      redefine
         make, set_width, set_precision, set_align_left,
         set_align_right, set_align_center
      end

feature {ABSTRACT_FORMATTER}

   width,prec : INTEGER
   alignment  : INTEGER
   align_left,
   align_right,
   align_center : INTEGER is unique

feature

   ---------------------------------------------------------make
   make,frozen abstract_justify_make(a : ANY) is
   do
      abstract_make(a)
      alignment := align_right
      width := 1
      prec := -1
   end
   ---------------------------------------------------------set_width
   set_width(w:INTEGER) is do width:=w end
   ---------------------------------------------------------set_precision
   set_precision(p:INTEGER) is do prec:=p end
   ---------------------------------------------------------set_align_left
   set_align_left  is do alignment := align_left end
   ---------------------------------------------------------set_align_right
   set_align_right is do alignment := align_right end
   ---------------------------------------------------------set_align_center
   set_align_center is do alignment := align_center end

end -- class ABSTRACT_JUSTIFY_FORMATTER
