indexing

   title:       "Date formatter with justify actions";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "date_fmt.e"

class DATE_FORMATTER
inherit
   STRING_FORMATTER
   undefine
      make
   redefine
      output
   select
      set_width, set_precision, set_sign, set_align_left, set_align_right,
      set_align_center, set_align_char, output
   end
   ABSTRACT_FORMATTER
   undefine
      set_width, set_precision, set_sign, set_align_left, set_align_right,
      set_align_center, set_align_char
   redefine
      make
   select
      make
   end


creation
    make

feature

   make, frozen date_make(d : DATE) is
   require else
      format_date : d /= Void
   local
      s : STRING
   do
      s:= ""
      x_append(s,make_two_digit(d.month_part))
      x_append(s,"/")
      x_append(s,make_two_digit(d.day_part))
      x_append(s,"/")
      x_append(s,make_two_digit(d.year_part\\100))
      string_make(s)
   end

   output : STRING is
   do
      if prec >= 8 then
         set_precision(8)
      elseif prec >= 5 then
         set_precision(5)
      elseif prec >= 2 then
         set_precision(2)
      else
         set_precision(0)
      end
      Result := string_output
   end

feature {NONE}
   make_two_digit(i : INTEGER) : STRING is
      local
         i_f : INTEGER_FORMATTER
      do
         !!i_f.make(i)
         i_f.set_width(2)
         i_f.set_align_char('0')
         Result := i_f.output
      end

end -- class DATE_FORMATTER
