indexing

   title:       "Demo for Commercial formats. Show all formats";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "abs_com.e"

class WIDTH

inherit
   MATH

creation make

feature

   sf : COMMERCIAL_FORMAT is
   once
      !!Result.make
   end

   make is
   local
      s : STRING
      i : INTEGER
      r : REAL
   do
      i := 360
      sf.printf("%N  Formatting of number !d%N",<<i>>)
      printf_int("!9999",i)
      printf_int("!ZZZZ",i)
      printf_int("!ZZZZ+",i)
      printf_int("!-ZZZZ",i)
      printf_int("!-----",i)
      printf_int("!$++99",i)

      i := -360
      sf.printf("%N  Formatting of number !d%N",<<i>>)
      printf_int("!9999",i)
      printf_int("!ZZZZ",i)
      printf_int("!ZZZZ+",i)
      printf_int("!-ZZZZ",i)
      printf_int("!-----",i)
      printf_int("!$++99",i)

      i :=0
      sf.printf("%N  Formatting of number !d%N",<<i>>)
      printf_int("!9999",i)
      printf_int("!ZZZZ",i)
      printf_int("!ZZZZ+",i)
      printf_int("!-ZZZZ",i)
      printf_int("!-----",i)
      printf_int("!$++99",i)

      s := "Very lazy programmer"
      printf_str("!XXXX",s)
      printf_str("!X(5)",s)
      printf_str("!X(0)",s)
      printf_str("!I(30)",s)
      printf_str("!I(30)[UPPER CHARACTER]",s)
      printf_str("!I(30)[LOWER CHARACTER]",s)
      printf_str("!X(30)[JUSTIFIED LEFT]",s)
      printf_str("!X(30)[JUSTIFIED RIGHT]",s)

      printf_fix("!99999.9",23.12345)
      printf_fix("!ZZZZZ.9",23.12345)
      printf_fix("!ZZZ.999$",23.12345)
      printf_fix("!ZZZ.999+",23.12345)
      printf_fix("!ZZZ.999+",-23.12345)

      sf.printf("L=<!(L)/!(L)>%N",<<True, False >>)
      sf.printf("Y=<!(Y)/!(Y)>%N",<<True, False >>)

      sf.set_currency("#")
      sf.set_decimal(',')
      printf_fix("!99999.9",23.12345)
      printf_fix("!ZZZZZ.9",23.12345)
      printf_fix("!ZZZ.999$",23.12345)
      printf_fix("!ZZZ.999+",23.12345)
      printf_fix("!ZZZ.999+",-23.12345)

   end


   printf_int(f : STRING, i : INTEGER) is
   do
      sf.printf("]!s[%T]",<<f>>)
      sf.printf(f,<<i>>)
      sf.printf("[%N",<<>>)
   end

   printf_str(f : STRING, s : STRING) is
   do
      sf.printf("]!s[%T]",<<f>>)
      sf.printf(f,<<s>>)
      sf.printf("[%N",<<>>)
      sf.printf("]!s[%T]123456789012345678901234567890%N",<<f>>)
   end

   printf_fix(f : STRING, r : REAL) is
   do
      sf.printf("]!s[%T]",<<f>>)
      sf.printf(f,<<r>>)
      sf.printf("[%N",<<>>)
   end

end -- class WIDTH
