indexing

   title:       "Container for the POSIX(typechar) formatters";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Andy Malakov  (andy@eiffel.ru) and";
   original:    08,Sep,1995;
   version:     1.0;
   last_change:
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "fmt_tb_t.e"

class TYPECHAR_FORMAT_TABLE [ G -> TYPECHAR_FORMATTER ]

   inherit
      FORMAT_TABLE [ G ]
         redefine
            add
         end

   creation
      make

   feature

      ----------------------------------------------------------------
      dyna_types, frozen std_dyna_types :
                         DYNATYPE_TABLE [ FORMAT_TABLE_ELEMENT ] is
         once
            !!Result.make
         end
      ----------------------------------------------------------------
      search_by_typechar ( typechar : CHARACTER ) is
         do
            from
               found_index := lower; found := false
            until
               found or else found_index > upper
            loop
               if item (found_index).typechar = typechar then
                  found_item := item(found_index)
                  found := true
               else
                  found_index  := found_index  + 1
               end
            end -- loop
         end -- search_by_typechar

   -------------------------------------------------------------------
   feature  -- operations
   -------------------------------------------------------------------
      add ( new_g : G ) is
         do
            -- typechar must be unique
            search_by_typechar ( new_g.typechar )
            if not found then
               fmt_add ( new_g )
            end
            dyna_types.add ( new_g )
         end -- add

end -- class TYPECHAR_FORMAT_TABLE

